#!/usr/bin/csh
#
# Create the database for LiveWire hours
#
setenv db tock

echo "Loading base data..."

dbaccess $db - <<!

insert into user (id,login,password,firstname,lastname,fullname,title,active,admin) values (1,'admin','admin','Admin','User','Admin User','Administrator','Y','Y');
insert into group (id,name) values (1,'Admin Group');
insert into group_people (user_id,group_id) values (1,1);
insert into category (id,name) values (1,'Administration');
insert into project (id,name) values (1,'Administration');
insert into user_projects (user_id,project_id) values (1,1);

insert into user (id,login,password,firstname,lastname,fullname,title,active,admin) values (2,'user','user','User','User','User User','User','Y','N');
insert into group (id,name) values (2,'User Group');
insert into group_people (user_id,group_id) values (2,2);
insert into category (id,name) values (2,'User Function');
insert into project (id,name) values (2,'User Work');
insert into user_projects (user_id,project_id) values (2,2);

!

echo "Done."
echo "An admin user has been created.  The login for the user is admin, "
echo "and the password is admin."
echo "A non-admin user has been created.  The login for the user is user,"
echo "and the password is user."
echo ""
echo "You can use these users to explore the system, or run the sample "
echo "data script to create some sample data."
echo ""
