create database tock with log;

database tock;

create table hours 
  (
    id serial not null constraint n103_9,
    date date not null constraint n103_10,
    user_id integer not null constraint n108_17,
    hours decimal(4,2) not null constraint n103_11,
    project_id integer not null constraint n103_12,
    category_id integer not null constraint n103_13,
    description varchar(255,1)
  );

create unique index ix103_1 on hours (id);
alter table hours add constraint primary key (id) constraint 
    hours_pk  ;

create table group_people 
  (
    user_id integer not null constraint n102_7,
    group_id integer not null constraint n102_8
  );

create table user_projects 
  (
    user_id integer not null constraint n109_17,
    project_id integer not null constraint n109_18
  );

create table user 
  (
    id serial not null constraint n100_1,
    login varchar(10,1) not null constraint n100_2,
    password varchar(10,1) not null constraint n100_3,
    firstname varchar(20,1),
    lastname varchar(20,1),
    fullname varchar(40,1),
    title varchar(80,1),
    phone varchar(14,1),
    email varchar(80,1),
    active char(1) not null constraint n100_4,
    status char(1),
    admin char(1),
    def_project integer,
    def_category integer
  );

create unique index ix100_1 on user (id);
alter table user add constraint primary key (id) constraint 
    user_pk  ;
create table category 
  (
    id serial not null constraint n105_15,
    name varchar(20,1)
  );

create unique index ix105_1 on category (id);
alter table category add constraint primary key (id) constraint 
    category_pk  ;
create table group 
  (
    id serial not null constraint n101_6,
    name varchar(20,1)
  );

create unique index ix101_1 on group (id);
alter table group add constraint primary key (id) constraint 
    group_pk  ;
create table project 
  (
    id serial not null constraint n104_14,
    name varchar(20,1),
    status char(1),
    billable char(1)
  );

create unique index ix104_1 on project (id);
alter table project add constraint primary key (id) constraint 
    project_pk  ;

alter table user add constraint (foreign key (def_project) 
    references project  constraint user_project_fk);

alter table user add constraint (foreign key (def_category) 
    references category  constraint user_category_fk);

alter table group_people add constraint (foreign key (user_id) 
    references user  constraint group_people_user);

alter table group_people add constraint (foreign key (group_id) 
    references group  constraint group_people_group);

alter table hours add constraint (foreign key (user_id) references 
    user  constraint hours_user_fk);

alter table hours add constraint (foreign key (project_id) references 
    project  constraint hours_project_fk);

alter table hours add constraint (foreign key (category_id) references 
    category  constraint hours_category_fk);

alter table user_projects add constraint (foreign key (user_id) 
    references user  constraint user_proj_user_fk);

alter table user_projects add constraint (foreign key (project_id) 
    references project  constraint user_proj_proj);


