
<!-- application: 	Tock 	-->
<!-- version: 		1.0 					-->
<!-- company name:	Internet Media Services 		-->
<!-- filename:		hours.js		 		-->
<!-- description:	this file contains numerous Java Script	-->
<!--			functions used throughout the 	 	-->
<!--			application.  see the documentation 	-->
<!--			for each individual function for more	-->
<!--			information.				-->

/*
  $Log: hours.js,v $
  Revision 1.34  1996/08/22 00:51:04  kimberly
  fix back button problem with edit entry

  Revision 1.33  1996/08/21 17:54:04  kimberly
  rename index.html to index.html; break long lines; add comments

  Revision 1.32  1996/08/09 18:08:53  kimberly
  add language=JavaScript in script tags

  Revision 1.31  1996/08/08 19:45:55  kimberly
  error checking for unauthorized viewing

  Revision 1.30  1996/08/08 17:47:26  kimberly
  add another backslash in backslashQuote to get a real backslash

  Revision 1.29  1996/08/08 01:13:58  kimberly
  layout and copy stuff

  Revision 1.28  1996/08/07 01:46:02  kimberly
  add group name to add group list

  Revision 1.27  1996/08/06 19:06:05  kimberly
  add group name after user name

  Revision 1.26  1996/08/06 18:45:32  kimberly
  add No Group group where users go when removed from a group.  cannot be edited or deleted

  Revision 1.25  1996/08/06 17:02:03  kimberly
  add code to deal with saving a change when someone else has already used that name

  Revision 1.24  1996/08/05 21:42:42  kimberly
  add parameter when redirecting to initial.html because of an error to prevent loading frames again

  Revision 1.23  1996/08/03 00:32:07  kimberly
  remove inactive projects list from project object and replace with all projects list

  Revision 1.22  1996/08/02 23:19:02  kimberly
  fix entriesExist to use numeric 0 instead of string 0

  Revision 1.21  1996/08/02 21:36:33  kimberly
  if a project has been inactivated, skip over it in writing the multi select and force a reload of the client active projects

  Revision 1.20  1996/08/02 19:50:47  kimberly
  remove debugging info and shorten lines

  Revision 1.19  1996/08/02 02:19:57  kimberly
  changes for flattened directory s structure

  Revision 1.18  1996/08/02 01:40:22  staal
  interface

  Revision 1.17  1996/08/01 18:03:42  kimberly
  add checks to deal with database errors

  Revision 1.16  1996/08/01 01:09:40  kimberly
  update flow control

  Revision 1.15  1996/07/31 17:53:28  kimberly
  use writeln to make generated HTML easier to read

  Revision 1.14  1996/07/29 19:06:40  kimberly
  add hoursObj object and formatHours function to print numbers with 2 decimal places

  Revision 1.13  1996/07/27 01:37:16  kimberly
  minor fixes for beta

  Revision 1.12  1996/07/27 01:23:10  regan
  graphics

  Revision 1.11  1996/07/27 00:29:18  kimberly
  add flow control for edit_entry

  Revision 1.10  1996/07/26 18:38:48  regan
  interface

  Revision 1.9  1996/07/26 02:18:26  regan
  add reports

  Revision 1.8  1996/07/25 18:42:32  kimberly
  add head variable to write button bar

  Revision 1.7  1996/07/25 16:27:00  kimberly
  remove absolute paths

  Revision 1.6  1996/07/25 00:19:03  kimberly
  add format number function

  Revision 1.5  1996/07/23 23:10:20  kimberly
  fix code dealing with bad password

  Revision 1.4  1996/07/23 19:28:02  kimberly
  remove requirement that user come from admin.html before add_ functions

  Revision 1.3  1996/07/23 18:55:05  kimberly
  Change hours_ims to tock_ims

  Revision 1.2  1996/07/23 18:53:12  kimberly
  Add Log tag
 
*/

<!-- ===================================================================== -->

<!-- makes generated html easier to read -->
function writeln(text)
{
   write(text + '\n');
}

<!-- ===================================================================== -->

<!-- constructor that holds the number of hours as a string (1.25) and -->
<!-- as its component parts (1 and 25) -->
<!-- hrs will probably be a query cursor object, so we can't do it it the -->
<!-- easy way and use string functions -->
function hoursObj(hrs) {
  var temp1, temp2;
  this.hours_string = hrs;
  this.hours = Math.floor(hrs);
  this.min = eval((eval(hrs) - this.hours)*100);
  if (this.min == 0) this.min = "00";
}


<!-- ===================================================================== -->

<!-- use hoursObj to construct a string like 1.00, 1.25, 1.50, 1.75 -->
function formatHours(number) {
  var hrs = new hoursObj(number);
  return hrs.hours+"."+hrs.min;
}	

<!-- ===================================================================== -->

<!-- change all single quotes to '' so they won't cause trouble in queries -->
function escQuote (query_string) {
  var new_string = "";
  var query_len = query_string.length;
  var c;

  if (query_string == "" || query_string.indexOf("'") < 0) 
    return query_string;  

  for (var i = 0; i < query_len; i++)  {
    c = query_string.charAt(i);  
    if (c != '\'')	new_string += c;
    else   		new_string += "''";
  }
  return new_string;
}

<!-- ===================================================================== -->

<!-- change single quotes to \' so they won't cause trouble in Java Script -->
function backslashQuote (s) {
  var new_string = "";
  var len = s.length;
  var c;

  if (s == "" || s.indexOf("'") < 0) 
    return s;  

  for (var i = 0; i < len; i++)  {
    c = s.charAt(i);  
    if (c != '\'')	new_string += c;
    else   		new_string += "\\'";
  }
  return new_string;
}

<!-- ===================================================================== -->

<!-- do database query and construct string containing ids and names: -->
<!-- id1 | name1 || id2 | name2 || ...                                    --> 
<!-- because properties of LiveWire objects can only be strings, not  -->
<!-- complex objects.                                                 -->
function createIdNameString(queryString) {
  var query;
  var temp;

  temp = "";
  query = database.cursor(queryString);
  while (query.next()) 
    temp += query[0]+" | "+query[1]+" || ";
  query.close();
  return temp;
}

<!-- ===================================================================== -->

<!-- do database query and construct string containing ids and names: -->
<!-- id1 | name1 (group1) || id2 | name2 (group2) || ...              --> 
<!-- because properties of LiveWire objects can only be strings, not  -->
<!-- complex objects.                                                 -->
function createIdNameGroupString(query_string) {
  var query;
  var temp;

  temp = "";
  query = database.cursor(query_string);
  while (query.next())  {
    if ((query[2]+"").indexOf("No Group") >= 0)
      temp += query[0]+" | "+query.fullname+" || ";
    else
      temp += query[0]+" | "+query.fullname+" ("+query[2]+") || ";
  }
  query.close();
  return temp;
}

<!-- ===================================================================== -->

<!-- check whether the login cookie is set.  return true if set, false     -->
<!-- false if not                                                          -->
function loggedIn() {
  var today = new Date;

  if (client.id == "null" || client.id == null)
    return false;
  if (! client["login"+((today.getYear()+today.getMonth())*client.id)])
    return false;
  if (client["login"+((today.getYear()+today.getMonth())*client.id)] 
	!= "yes") 
    return false;  
  return true;
}

<!-- ===================================================================== -->

<!-- set the cookie used to check if user has logged in -->
function setLoggedIn() {
  var today = new Date();

  client["login"+((today.getYear()+today.getMonth())*client.id)] = "yes"; 
}

<!-- ===================================================================== -->

<!-- unset the cookie used to check if user has logged in -->
function setLoggedOut() {
  var today = new Date();

  if (client.id != null && client.id != "null") 
    client["login"+((today.getYear()+today.getMonth())*client.id)] = null; 
}

<!-- ===================================================================== -->

<!-- constructor for object used to step through id|name  lists -->
function IdNameObj() {
  this.id = "";
  this.name = "";
  this.currPos = 0;
}

<!-- ===================================================================== -->

<!-- get next id/name pair from id|name string: id name || id name || ...  -->
function getNextItem(s,item) {
  var nextPos;

  nextPos = s.indexOf(" |",item.currPos);
  item.id = s.substring(item.currPos,nextPos);
  item.currPos = nextPos+3;
  nextPos = s.indexOf(" ||", item.currPos);
  item.name = s.substring(item.currPos,nextPos);
  item.currPos = nextPos+4;
}

<!-- ===================================================================== -->

<!-- write a multi select list with the list of items in selectList	-->
<!-- selected.  list and selectList must both be sorted			-->
<!-- returns true if all items in selectList were found in list, false 	-->
<!-- if not.  								-->
function writeSelectMultiOptions(list,selectList) {
  var item = new IdNameObj();
  var selectItem = new IdNameObj;
  var allItemsFound = true;

  getNextItem(selectList,selectItem);
  while (item.currPos < list.length) {
    getNextItem(list,item);
    // current item in select list not found in list
    if (item.name > selectItem.name && 
	selectItem.currPos < selectList.length) {
      getNextItem(selectList,selectItem);
      allItemsFound = false;
    }
    if (item.id == selectItem.id) { 
      writeln("  <option value=\""+item.id+"\" selected>"+item.name);
      if (selectItem.currPos < selectList.length) 
        getNextItem(selectList,selectItem);
    }
    else 
      writeln("  <option value=\""+item.id+"\">"+item.name);
  }
  return allItemsFound;
}
<!-- ===================================================================== -->

<!-- write a select list with the user's default property selected       -->
function writeSelectOptions(list,client_prop) {
  var item = new IdNameObj();

  while (item.currPos < list.length) {
    getNextItem(list,item);
    if (item.id == client_prop) 
      writeln("  <option value=\""+item.id+"\" selected>"+item.name);
    else 
      writeln("  <option value=\""+item.id+"\">"+item.name);
  }
}
<!-- ===================================================================== -->

<!-- write the items in list as hidden fields, each named                  -->
<!-- <name_prefix><item.id> and with value <item.name>                     -->
<!-- this can be useful when you want to pass both the id and name as the  -->
<!-- result of a select (put the id in the select list and use             -->
<!-- request[name_prefix+request.selected_item] to get the name)           -->
function writeHiddenList(list,name_prefix) {
  var item = new IdNameObj();

  while (item.currPos < list.length) {
    getNextItem(list,item);
    writeln("  <input type=\"hidden\" name=\""+name_prefix+item.id+"\" "+
	"value=\""+item.name+"\">");
  }
}

<!-- ===================================================================== -->

<!-- return "Y" if user has admin privileges, "N" if not                   -->
function lookupAdminStatus(user_id) {
  var query;

  query = database.cursor("select admin from user where id="+user_id);
  if (query.next()) {
    if (query.admin+"" == "Y") {
      query.close();
      return "Y";
    }
    else {
      query.close();
      return "N";
    }
  }
  else  {
    query.close();
    return "N";
  }
}

<!-- ===================================================================== -->

<!-- Load the user's default project and hour type preferences and list of -->
<!-- default projects from the database                                    -->
function loadPrefs() {
  var query;

  if (client.defproject == null || client.defproject == null || 
      client.defproject == "null" || client.defproject == "null")  {
    query = database.cursor(
	"select def_project,def_category from user where id="+client.id);
    if (query.next()) {
      client.defproject = query.def_project;
      client.defcategory = query.def_category;
    }
    query.close();
  }
  if (client.active_project_list == null || client.active_project_list == 
      "null"  || client.active_project_list == "")  
    client.active_project_list = createIdNameString(
	"select distinct id,name from project,user_projects where "+
	"project_id=id and user_id="+client.id+" order by name"); 
}

<!-- ===================================================================== -->

<!-- Load employee names and ids into the project object so it only has to -->
<!-- be done once per application.                                         -->
<!-- This loads all employees, active and inactive, since only admins can  -->
<!-- see a list of employees                                               -->
function loadEmployees() {
  if (project.emp_list == null || project.emp_list == "null"  || 
      project.emp_list == "")  
    project.emp_list = createIdNameString("select distinct id,fullname,"+
	"firstname,lastname from user order by lastname,firstname");
}

<!-- ===================================================================== -->

<!-- Load group names and ids into the project object so it only has to    -->
<!-- be done once per application.                                         -->

function loadGroups() {
  if (project.group_list == null || project.group_list == "null"  || 
      project.group_list == "")  
    project.group_list = createIdNameString(
	"select distinct id,name from group where name != '   No Group   ' order by name");
}

<!-- ===================================================================== -->

<!-- Load active project names and ids into the project object so it only  -->
<!-- has to be done once per application.                                  -->

function loadProjects() {
  if (project.project_list == null || project.project_list == "null"  || 
      project.project_list == "")  
    project.project_list = createIdNameString(
	"select distinct id,name from project where status='A' order by name");
}

<!-- ===================================================================== -->

<!-- Load all project project names and ids, including inactive ones, into -->
<!-- the project object so it only has to be done once per application.    -->

function loadAllProjects() {
  if (project.all_projects_list == null || 
      project.all_projects_list == "null"  || 
      project.all_projects_list == "")  
    project.all_projects_list = createIdNameString(
	"select distinct id,name from project order by name");
}

<!-- ===================================================================== -->

<!-- Load category names and ids into the project object so it only has to -->
<!-- be done once per application.                                         -->

function loadCategories() {
  if (project.category_list == null || project.category_list == "null" || 
      project.category_list == "") 
    project.category_list = createIdNameString(
	"select distinct id,name from category order by name");
}

<!-- ===================================================================== -->

<!-- does a select count with the supplied from...where clause             -->
<!-- returns true if count != 0                                            -->
function entriesExist(from_where) {
  var query;

  query = database.cursor("select count(*) "+from_where);
  if (query.next()) {
    if (query[0] == 0) {
      query.close();
      return false;
    }
    else {
      query.close();
      return true;
    }
  }
  else 
    return false;
}
<!-- ===================================================================== -->

<!-- page flow is defined here!!  -->
<!-- check if prevPage is valid, and if not, redirect to login screen -->
function checkPrevPage(currPage) {
  <!-- seems to be weird pointer problems when:  -->
  <!-- currPrevPage = client.prevPage;           -->
  <!-- client.prevPage = currPage;               -->
  <!-- then, currPrevPage == lti_entry.html      -->
  <!-- tried it this way to return right away instead of going through all -->
  <!-- if statements -->
  var cp = currPage;
  var pp = client.prevPage;

  if (!database.connected()) 
    redirect("initial.html?err=1");
  if (!loggedIn() && cp != "login.html")
    redirect("initial.html?err=1");

  <!-- these pages have no prerequisites: (other than login)              -->
  <!--   multi_entry.html, user_info.html, get_dates.html, -->
  <!--   admin.html, logout.html                                    -->
  if (cp == "multi_entry.html" || cp == "user_info.html" || 
      cp == "get_dates.html" || cp == "admin.html" ||
      cp == "logout.html") {
    client.prevPage = cp;
    return;
  }

  if ((cp == "login.html") && (pp != "initial.html submit")) 
      redirect("initial.html?err=1");
  if ((cp == "process_multi.html") &&  (pp != "multi_entry.html submit")) 
      redirect("initial.html?err=1");
  if ((cp == "edit_entry.html") && (pp != "do_report.html") &&
       (pp != "do_edit_entry.html") &&  (pp != "edit_entry.html"))
      redirect("initial.html?err=1");
  if ((cp == "do_edit_entry.html") && (pp != "edit_entry.html submit") && 
      (pp != "do_edit_entry.html"))
      redirect("initial.html?err=1");
  if ((cp == "do_edit_user.html") && (pp != "user_info.html submit")) 
      redirect("initial.html?err=1");
  if ((cp == "do_add_user.html") && (pp != "add_user.html submit")) 
      redirect("initial.html?err=1");
  if ((cp == "do_add_group.html") && (pp != "add_group.html submit")) 
      redirect("initial.html?err=1");
  if ((cp == "do_add_project.html") && (pp != "add_project.html submit")) 
      redirect("initial.html?err=1");
  if ((cp == "do_add_category.html") &&  (pp != "add_category.html submit")) 
      redirect("initial.html?err=1");
  if ((cp == "edit_user.html") && (pp != "admin.html submit") &&
	(pp != "do_edit_user.html"))
        redirect("initial.html?err=1");
  if ((cp == "edit_group.html") && (pp != "admin.html submit") &&
	(pp != "do_edit_group.html"))
        redirect("initial.html?err=1");
  if ((cp == "edit_project.html") && (pp != "admin.html submit") &&
	(pp != "do_edit_project.html"))
        redirect("initial.html?err=1");
  if ((cp == "edit_category.html") && (pp != "admin.html submit") &&
	(pp != "do_edit_category.html"))
        redirect("initial.html?err=1");
  if ((cp == "do_edit_group.html") && (pp != "edit_group.html submit")) 
      redirect("initial.html?err=1");
  if ((cp == "do_edit_project.html") && (pp != "edit_project.html submit")) 
      redirect("initial.html?err=1");
  if ((cp == "do_edit_category.html") && (pp != "edit_category.html submit")) 
      redirect("initial.html?err=1");  
  if ((cp == "do_report.html") && (pp != "reports.html submit") &&
	(pp != "multi_entry.html submit"))
      redirect("initial.html?err=1"); 
  if ((cp == "do_reset_pw.html") && (pp != "user_info.html") && 
      (pp != "do_reset_pw.html"))
      redirect("initial.html?err=1"); 
  if ((cp == "do_change_pw.html") && (pp != "change_pw.html submit"))
      redirect("initial.html?err=1"); 

  client.prevPage = currPage;
}

<!-- ===================================================================== -->











