
<!-- application: 	Tock 	-->
<!-- version: 		1.0 					-->
<!-- company name:	Internet Media Services 		-->
<!-- filename:		db_down.html		 		-->
<!-- description:	this file contains functions which write 	-->
<!--			client-side JavaScript. If a function needs 	-->
<!--			to change, it can be updated once here instead	-->
<!-- 			of in every file that uses it.			-->
<!--			This could be also be done using the		-->
<!--			<script src=...> 				-->
<!--			method.  The application was originally 	-->
<!--			developed for browsers which did not support	-->
<!--			this method.					-->
<!-- ===================================================================== -->


<!-- write the fixYear JavaScript function -->
function writeFixYear() {
  writeln("<script language=\"JavaScript\">");
  writeln("<!-- if date < 70, convert to 20xx, so 7/22/00 will mean 7/22/2000 -->");
  writeln("<!-- Informix thinks two digit years are 19xx and LiveWire can't deal -->");
  writeln("<!-- with dates before 1970 -->");
  writeln("<!-- this function should be called *after* the date has been checked for -->");
  writeln("<!-- validity, since it does not do that type of error checking -->");
  writeln("<!-- returns the date with a 4 digit year if the year is less than 2000 -->");
  writeln("function fixYear(date) {");
  writeln("  var date_len = date.length;");
  writeln("  var firstSlash = date.indexOf(\"/\");");
  writeln("  var secondSlash = date.lastIndexOf(\"/\");");
  writeln("  if (firstSlash == secondSlash) {");
  writeln("    var today = new Date();");
  writeln("    date += \"/\"+today.getYear();");
  writeln("    return date;");
  writeln("  }");
  writeln("  var year = date.substring(secondSlash+1,date_len);");
  writeln("");
  writeln("  if (year < 70) {");
  writeln("    year = eval(year)+2000;");
  writeln("    date = date.substring(0,date.lastIndexOf(\"/\")+1);");
  writeln("    date += year;");
  writeln("  }");
  writeln("  return date;");
  writeln("}");
  writeln("</script>");

}

<!-- ===================================================================== -->

<!-- write the checkDate Java Script function -->
function writeCheckDate() {

  writeln("<script language=\"JavaScript\">");
  writeln("<!-- returns true if date is valid, false if not. alerts if date is invalid -->");
  writeln("<!-- takes date field and field_name (for use in invalid alert) -->");
  writeln("function checkDate(date_field,field_name) {");
  writeln("  var first_slash = date_field.value.indexOf(\"/\");");
  writeln("  if (date_field.value == \"\" || first_slash == -1) {");
  writeln("    alert(field_name+\": You must enter a date in mm/dd/yy format!\");");
  writeln("    date_field.focus();");
  writeln("    date_field.select();");
  writeln("    return false;");
  writeln("  }");
  writeln("  var second_slash = eval(date_field.value.indexOf(\"/\",first_slash+1));");
  writeln("  var mon = date_field.value.substring(0,first_slash);");
  writeln("  var day;");
  writeln("  var yr;");
  writeln("  if (second_slash == -1) { ");
  writeln("    var today = new Date();");
  writeln("    day = date_field.value.substring(first_slash+1,date_field.value.length);");
  writeln("    yr = today.getYear();");
  writeln("  }");
  writeln("  else {");
  writeln("    day = date_field.value.substring(first_slash+1,second_slash);");
  writeln("    yr = date_field.value.substring(second_slash+1,date_field.value.length);");
  writeln("  }");
  writeln("");
  writeln("  if (eval(mon) < 1 || eval(mon) > 12 || eval(day) < 1 || eval(day) > 31) {");
  writeln("    alert(field_name+\": Invalid date!  You must enter a date in mm/dd/yy format!\");");
  writeln("    date_field.focus();");
  writeln("    date_field.select();");
  writeln("    return false;");
  writeln("  }");
  writeln("  if ((mon == 4 || mon == 6 || mon == 10 || mon == 11) && ");
  writeln("	(day < 1 || day > 30)) {");
  writeln("    alert(field_name+\": \"+day+\" is an invalid day.  Please enter a day between 1 and 30\");");
  writeln("    date_field.focus();");
  writeln("    date_field.select();");
  writeln("    return false;");
  writeln("  }");
  writeln("  if (mon == 2 && (day < 1 || day > 29)) {");
  writeln("    alert(field_name+\": \"+day+\" is an invalid day.  Please enter a day between 1 and 28\");");
  writeln("    date_field.focus();");
  writeln("    date_field.select();");
  writeln("    return false;");
  writeln("  }");
  writeln("  return true;");
  writeln("}");
  writeln("</script>");
}
<!-- ===================================================================== -->

<!-- write the dateCmp Java Script function			-->
function writeDateCmp() {

  writeln("<script language=\"JavaScript\">");
  writeln("");
  writeln("<!-- compares two (valid) dates.  -->");
  writeln("<!-- returns -1 if d1 < d2, 0 if d1 = d2, and 1 if d1 > d2 -->");
  writeln("function dateCmp(date1,date2) {");
  writeln("  if (date1 == date2)");
  writeln("    return 0;");
  writeln("");
  writeln("  var month1,day1,year1,month2,day2,year2;");
  writeln("  year1 = date1.substring(date1.lastIndexOf(\"/\")+1,date1.length);");
  writeln("  year2 = date2.substring(date2.lastIndexOf(\"/\")+1,date2.length);");
  writeln("");
  writeln("  // make 96 and 1996 equal");
  writeln("  if (year1.length != year2.length) ");
  writeln("    if (year1.length == 4) ");
  writeln("      if (eval(year2) >= 70) year2 = 1900+eval(year2); ");
  writeln("      else year2 = 2000+eval(year2);");
  writeln("    else if (year2.length == 4)");
  writeln("      if (eval(year1) >= 70) year1 = 1900+eval(year1);");
  writeln("      else year1 = 2000+eval(year1);");
  writeln("  if (eval(year1) < eval(year2))");
  writeln("    return -1;");
  writeln("  if (eval(year1) > eval(year2))");
  writeln("    return 1;");
  writeln("");
  writeln("  month1 = date1.substring(0,date1.indexOf(\"/\"));");
  writeln("  month2 = date2.substring(0,date2.indexOf(\"/\"));");
  writeln("  if (eval(month1) < eval(month2))");
  writeln("    return -1;");
  writeln("  if (eval(month1) > eval(month2))");
  writeln("    return 1;");
  writeln("");
  writeln("  day1 = date1.substring(date1.indexOf(\"/\")+1,date1.lastIndexOf(\"/\"));");
  writeln("  day2 = date2.substring(date2.indexOf(\"/\")+1,date2.lastIndexOf(\"/\"));");
  writeln("  if (eval(day1) < eval(day2))");
  writeln("    return -1;");
  writeln("  if (eval(day1) > eval(day2))");
  writeln("    return 1;");
  writeln("");
  writeln("  return 0;");
  writeln("}");
  writeln("</script>");
}
<!-- ===================================================================== -->

<!-- write the checkTextQuotes Java Script function			-->
function writeCheckTextQuotes() {

  writeln("<script language=\"JavaScript\">");
  writeln("");
  writeln("<!-- check for single or double quotes and alert if found  -->");
  writeln("<!-- returns true if field is ok, false if invalid         -->");
  writeln("<!-- arguments: 					      -->");
  writeln("<!--   quote_type  single, double or both (single double)  -->");
  writeln("<!--   field       field value to check                    -->");
  writeln("<!--   label       label for alert                         -->");
  writeln("function checkTextQuotes(quote_type,field,label) {");
  writeln("  if (! field)");
  writeln("    return true;");
  writeln("  if (quote_type.indexOf(\"single\") >= 0)");
  writeln("    if (field.indexOf(\"'\") >= 0) {");
  writeln("      alert(\"Invalid \"+label+\"! Single quotes (') not allowed in \"+label+\".\");");
  writeln("      return false;");
  writeln("  }");
  writeln("  if (quote_type.indexOf(\"double\") >= 0)");
  writeln("    if (field.indexOf(\"\\\"\") >= 0) {");
  writeln("      alert(\"Invalid \"+label+\"! Double quotes (\\\") not allowed in \"+label+\".\");");
  writeln("      return false;");
  writeln("  }");
  writeln("  return true;  ");
  writeln("}");
  writeln("</script>");
}

<!-- ===================================================================== -->

<!-- write the checkDefProj Java Script function			-->
function writeCheckDefProj() {
  writeln("<script language=\"JavaScript\">");
  writeln("function checkDefProj(def_project, active_projects) {");
  writeln("  var i;");
  writeln("  if (def_project.selectedIndex <= 0)");
  writeln("    return true;  ");
  writeln("  if (! active_projects.options[def_project.selectedIndex-1].selected) {");
  writeln("    alert(\"The default project must be one of the active projects!\");");
  writeln("    return false;");
  writeln("  }");
  writeln("  return true;    ");
  writeln("}");
  writeln("</script>");
}

